﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10.2
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim CommentColor As Int = 0xFF008000 ' Green
	Dim NumberColor As Int = 0xFF800080 ' Purple
	Dim StringColor As Int = 0xFFA31515 ' Reddish
	Dim KeywordColor As Int = 0xFF0000FF ' Blue
	Dim ScriptColor As Int = 0xFF0060E0 'Blueish
	Public ErrorColor As Int = 0xffff6060 ' Desaturated red for visibility	
	
	Public AC_NONE As Int = 0 ' none
	Public AC_BASIC As Int = 1 ' name and parentheses
	Public AC_PARAMS As Int = 2 ' name, parentheses and commas
	Public AC_FULL As Int = 3 ' name, parentheses, commas and param names
	
End Sub

Public Sub AddSyntax(edtSource As CodeEditorView)
	
'	'Keywords B4AScript	
	Dim scriptwordlist As List
	Dim sb As StringBuilder
	sb.Initialize
	scriptwordlist = File.ReadList(File.DirAssets, "BasicIDEKeywordsHighlight.txt")
	' add all the keywordslist entries into a string pattern
	sb.Append("(\b(")
	For i = 0 To scriptwordlist.Size - 1
		sb.Append(scriptwordlist.Get(i)).append("|")
	Next
	' remove last pipe character
	sb.Remove(sb.Length-1, sb.Length)
	' complete the pattern and add it
	sb.Append(")\b)")
	edtSource.AddSyntaxPattern(sb.ToString, KeywordColor, True)

	' Keywords - Script module functions
	Dim scriptwordlist As List
	Dim sb As StringBuilder
	sb.Initialize
	scriptwordlist = File.ReadList(File.DirAssets, "BasicIDEScriptHighlight.txt")
	' add all the keywordslist entries into a string pattern
	sb.Append("(\b(")
	For i = 0 To scriptwordlist.Size - 1
		sb.Append(scriptwordlist.Get(i)).append("|")
	Next
	' remove last pipe character	sb.Remove(sb.Length-1, sb.Length)	
	sb.Remove(sb.Length-1, sb.Length)
	' complate the pattern and add it
	sb.Append(")\b)")
	edtSource.AddSyntaxPattern(sb.ToString, ScriptColor, True)
	
	' Numbers - integer, decimal, engineering and hex 
	edtSource.AddSyntaxPattern("(\b\d+[\.]?\d*([eE]\-?\d+)?[lLdDfF]?\b|\b0x[a-fA-F\d]+\b)", NumberColor, False)
	
	'Strings - strings using either ' or " as the delimiters
	edtSource.AddSyntaxPattern("(\'(?:[^\']|\'\')*\'|\'(?:\\.|[^\\\'])*(\'|\\b))", StringColor, True)
	edtSource.AddSyntaxPattern("(\" & Chr(34) & "(?:[^\" & Chr(34) & "]|\" & Chr(34) & "\" & Chr(34) & ")*\" & Chr(34) & "|\" & Chr(34) & "(?:\\.|[^\\\" & Chr(34) & "])*(\" & Chr(34) & "|\\b))", StringColor, True)
	
	' Comments - lines beginning with whitespace and "REM " or "#"
	' The patterns are applied in the order in which they are added.
	' Adding these last prevents keywords in the comments being highlighted so avoiding complex keyword regexes.
	edtSource.AddSyntaxPattern("^[0-9 :]*\s*(#.*)", CommentColor, True)
	edtSource.AddSyntaxPattern("^[0-9 :]*\s*(rem .*)", CommentColor, True)
	
End Sub


Public Sub AddAutoComplete(edtSource As CodeEditorView, mode As Int)
	' we will add all the words in the keyword list as autocomplete entried
	Dim keywordlist As List
	keywordlist.Initialize
	
	' get the resource Ids needed for AddAutoCompleteWords
	Dim jo As JavaObject
	jo.InitializeStatic("anywheresoftware.b4a.agraham.basicide.syntax")
	Dim layoutId As Int = jo.runMethod("getlayoutid", Null)
	Dim viewId As Int = jo.runMethod("getviewid", Null)
	
	If mode < AC_BASIC Or mode > AC_FULL Then
		' we can't disable it so we give it nothing to match
		edtSource.AddAutoCompleteWords(layoutId, viewId, Array As String())	
		Return
	End If
	
	' add B4AScript keywordsto keywordslist
	Dim wordlist As List
	wordlist = File.ReadList(File.DirAssets, "BasicIDEKeywordsAutocomplete.txt")
	keywordlist.AddAll(wordlist)	
	
	' add Script module additional functions to keywordslist
	wordlist = File.ReadList(File.DirAssets, "BasicIDEScriptAutocomplete.txt")
	keywordlist.AddAll(wordlist)

	keywordlist.SortCaseInsensitive(True) ' need this as autocomplete doesn't seem to sort properly
	' add all the keywordslist entries into a string array
	Dim keywords(keywordlist.Size) As String
	For i = 0 To keywords.Length - 1
		keywords(i) = AdjustEntry(keywordlist.Get(i), mode)
	Next
	
	' and finally add the string array containing all the autocomplete words
	edtSource.AddAutoCompleteWords(layoutId, viewId, keywords)
End Sub


Sub AdjustEntry(entry As String, mode As Int) As String
	Dim idx1  As Int
	Dim name, params, commas As String
	Select mode
		Case  AC_FULL ' name, parentheses, commas and param names
			Return entry
						
		Case AC_PARAMS ' name, parentheses and commas
			idx1 = entry.IndexOf("(")
			If idx1 < 0 Then
				Return entry ' no parentheses
			End If
			name = entry.SubString2(0, idx1) 
			params = entry.SubString(idx1)
			commas = "("
			idx1 = params.IndexOf(",")
			Do While idx1 > 0 
				commas = commas & ","
				idx1 = params.IndexOf2(",", idx1+1)			
			Loop			
			commas = commas & ")"
			
			Return name & commas
		Case AC_BASIC ' name and parentheses
			idx1 = entry.IndexOf("(")
			If idx1 > 0 Then
				entry = entry.SubString2(0, idx1) & "()"
			End If
			Return entry
			
	End Select	
	Return entry 'should never get here but satisifies the compiler
End Sub


#if Java	
	public static int getlayoutid() {
	   return R.layout.autocomplete;
	}	
	public static int getviewid() {
	   return R.id.autocompleteTextView;
	}
#End If
